Index: src/arch/i386/boot/tables.c
===================================================================
--- src/arch/i386/boot/tables.c.orig
+++ src/arch/i386/boot/tables.c
@@ -10,38 +10,12 @@
 #include <arch/acpi.h>
 #include "linuxbios_table.h"
 
-// Global Descriptor Table, defined in c_start.S
-extern uint8_t gdt;
-extern uint8_t gdt_end;
-
-/* i386 lgdt argument */
-struct gdtarg {
-	unsigned short limit;
-	unsigned int base;
-} __attribute__((packed));
-
-// Copy GDT to new location and reload it
-// 2003-07 by SONE Takeshi
-// Ported from Etherboot to LinuxBIOS 2005-08 by Steve Magnani
-void move_gdt(unsigned long newgdt)
-{
-	uint16_t num_gdt_bytes = &gdt_end - &gdt;
-	struct gdtarg gdtarg;
-
-	printk_debug("Moving GDT to %#lx...", newgdt);
-	memcpy((void*)newgdt, &gdt, num_gdt_bytes);
-	gdtarg.base = newgdt;
-	gdtarg.limit = num_gdt_bytes - 1;
-	__asm__ __volatile__ ("lgdt %0\n\t" : : "m" (gdtarg));
-	printk_debug("ok\n");
-}
-
 struct lb_memory *write_tables(void)
 {
 	unsigned long low_table_start, low_table_end, new_low_table_end;
 	unsigned long rom_table_start, rom_table_end;
 
-	rom_table_start = 0xf0000;
+	rom_table_start = 0xf0000; 
 	rom_table_end =   0xf0000;
 	/* Start low addr at 16 bytes instead of 0 because of a buglet
 	 * in the generic linux unzip code, as it tests for the a20 line.
@@ -59,55 +33,48 @@ struct lb_memory *write_tables(void)
 	/* write them in the rom area because DSDT can be large (8K on epia-m) which
 	 * pushes linuxbios table out of first 4K if set up in low table area 
          */
-
 	rom_table_end = write_acpi_tables(rom_table_end);
 	rom_table_end = (rom_table_end+1023) & ~1023;
 
-	/* copy the smp block to address 0 */
-	post_code(0x96);
+        /* copy the smp block to address 0 */
+        post_code(0x96);
 
-	/* The smp table must be in 0-1K, 639K-640K, or 960K-1M */
-	new_low_table_end = write_smp_table(low_table_end);
+        /* The smp table must be in 0-1K, 639K-640K, or 960K-1M */
+        new_low_table_end = write_smp_table(low_table_end); // low_table_end is 0x10 at this point
 
-#if HAVE_MP_TABLE==1
+#if HAVE_MP_TABLE
         /* Don't write anything in the traditional x86 BIOS data segment,
          * for example the linux kernel smp need to use 0x467 to pass reset vector
          */
-        if(new_low_table_end>0x467){
-                unsigned mptable_size = new_low_table_end - low_table_end - SMP_FLOATING_TABLE_LEN;
-                /* We can not put mptable here, we need to copy them to somewhere else*/
-                if((rom_table_end+mptable_size)<0x100000) {
-                        /* We can copy mptable on rom_table, and leave low space for lbtable  */
-                        printk_debug("move mptable to 0x%0x\n", rom_table_end);
-                        memcpy((unsigned char *)rom_table_end, (unsigned char *)(low_table_end+SMP_FLOATING_TABLE_LEN), mptable_size);
-                        memset((unsigned char *)low_table_end, '\0', mptable_size + SMP_FLOATING_TABLE_LEN);
-                        smp_write_floating_table_physaddr(low_table_end, rom_table_end);
-                        low_table_end += SMP_FLOATING_TABLE_LEN;
-                        rom_table_end += mptable_size;
-                        rom_table_end = (rom_table_end+1023) & ~1023;
-                } else {
-                        /* We can need to put mptable low and from 0x500 */
-                        printk_debug("move mptable to 0x%0x\n", 0x500);
-                        memcpy((unsigned char *)0x500, (unsigned char *)(low_table_end+SMP_FLOATING_TABLE_LEN), mptable_size);
-                        memset((unsigned char *)low_table_end, '\0', 0x500-low_table_end);
-                        smp_write_floating_table_physaddr(low_table_end, 0x500);
-                        low_table_end = 0x500 + mptable_size;
-                }
-        }
-#endif 
-
-	/* Don't write anything in the traditional x86 BIOS data segment */
-	if (low_table_end < 0x500) {
+	if(new_low_table_end>0x467){
+		unsigned mptable_size;
+		unsigned mpc_start;
+		low_table_end += SMP_FLOATING_TABLE_LEN; /* keep the mpf in 1k low, so kernel can find it */
+		mptable_size = new_low_table_end - low_table_end;
+		/* We can not put mptable low, we need to copy them to somewhere else*/
+		if((rom_table_end+mptable_size)<0x100000) {
+			/* We can copy mptable on rom_table  */
+			mpc_start = rom_table_end;
+			rom_table_end += mptable_size;
+			rom_table_end = (rom_table_end+1023) & ~1023;
+		} else {
+			/* We can need to put mptable before rom_table */
+			mpc_start = rom_table_start - mptable_size;
+			mpc_start &= ~1023;
+			rom_table_start = mpc_start;
+		}
+		printk_debug("move mptable from 0x%0x to 0x%0x, size 0x%0x\n", low_table_end, mpc_start, mptable_size);
+		memcpy((unsigned char *)mpc_start, (unsigned char *)low_table_end, mptable_size);
+		smp_write_floating_table_physaddr(low_table_end - SMP_FLOATING_TABLE_LEN, mpc_start);
+		memset((unsigned char *)low_table_end, '\0', mptable_size);
+	}
+#endif
+	if(low_table_end<0x500) {
 		low_table_end = 0x500;
 	}
 
-	// Relocate the GDT to reserved memory, so it won't get clobbered
-	move_gdt(low_table_end);
-	low_table_end += &gdt_end - &gdt;
-
 	/* The linuxbios table must be in 0-4K or 960K-1M */
-	write_linuxbios_table(
-			      low_table_start, low_table_end,
+	write_linuxbios_table(low_table_start, low_table_end,
 			      rom_table_start, rom_table_end);
 
 	return get_lb_mem();
Index: src/arch/i386/boot/acpi.c
===================================================================
--- src/arch/i386/boot/acpi.c.orig
+++ src/arch/i386/boot/acpi.c
@@ -8,8 +8,8 @@
  * Nick Barker <nick.barker9@btinternet.com>, and those portions
  *  (C) Copyright 2004 Nick Barker
  *
- * Copyright 2005 ADVANCED MICRO DEVICES, INC. All Rights Reserved.
- * 2005.9 yhlu add SRAT table generation
+ * Copyright 2005 AMD
+ * 2005.9 yhlu add SRAT related
  */
 
 /* 
@@ -220,7 +220,7 @@ void acpi_create_slit(acpi_slit_t *slit)
         header->length = sizeof(acpi_slit_t);
         header->revision = 1;
 
-//        current = acpi_fill_slit(current);
+        current = acpi_fill_slit(current);
 
         /* recalculate length */
         header->length= current - (unsigned long)slit;
Index: src/arch/i386/include/stdint.h
===================================================================
--- src/arch/i386/include/stdint.h.orig
+++ src/arch/i386/include/stdint.h
@@ -67,5 +67,9 @@ typedef unsigned long int  uintmax_t;
 
 #undef __HAVE_LONG_LONG__
 
+typedef uint8_t u8;
+typedef uint16_t u16;
+typedef uint32_t u32;
+
 
 #endif /* I386_STDINT_H */
Index: src/arch/i386/include/arch/acpi.h
===================================================================
--- src/arch/i386/include/arch/acpi.h.orig
+++ src/arch/i386/include/arch/acpi.h
@@ -17,9 +17,6 @@
 
 #if HAVE_ACPI_TABLES==1
 
-typedef unsigned char u8;
-typedef unsigned short u16;
-typedef unsigned int u32;
 typedef unsigned long long u64;
 
 #define RSDP_SIG              "RSD PTR "  /* RSDT Pointer signature */
@@ -83,7 +80,7 @@ typedef struct acpi_table_header        
 /* RSDT */
 typedef struct acpi_rsdt {
 	struct acpi_table_header header;
-	u32 entry[6+ACPI_SSDTX_NUM]; /* HPET, FADT, SRAT, SLIT, MADT(APIC), SSDT, SSDTX*/
+	u32 entry[6+ACPI_SSDTX_NUM+CONFIG_MAX_CPUS]; /* HPET, FADT, SRAT, SLIT, MADT(APIC), SSDT, SSDTX, and SSDT for CPU pstate*/
 } __attribute__ ((packed)) acpi_rsdt_t;
 
 /* XSDT */
Index: src/arch/i386/init/crt0.S.lb
===================================================================
--- src/arch/i386/init/crt0.S.lb.orig
+++ src/arch/i386/init/crt0.S.lb
@@ -37,7 +37,8 @@
 
 #include "crt0_includes.h"
 
-#if USE_DCACHE_RAM == 0
+#if USE_DCACHE_RAM == 0   /* for cache as ram, we will use copy_and_run.c instead */
+
 #ifndef CONSOLE_DEBUG_TX_STRING
 	/* uses:	 esp, ebx, ax, dx */
 # define __CRT_CONSOLE_TX_STRING(string) \
@@ -215,7 +216,7 @@ crt_console_tx_string:
 
 #if defined(CONSOLE_DEBUG_TX_STRING) && (ASM_CONSOLE_LOGLEVEL > BIOS_DEBUG)
 .section ".rom.data"
-str_copying_to_ram:  .string "Copying LinuxBIOS to RAM.\r\n"
+str_copying_to_ram:  .string "Copying LinuxBIOS to ram.\r\n"
 str_pre_main:        .string "Jumping to LinuxBIOS.\r\n"
 .previous
 
Index: src/arch/i386/lib/console_ram.c
===================================================================
--- /dev/null
+++ src/arch/i386/lib/console_ram.c
@@ -0,0 +1,54 @@
+#if CONFIG_USBDEBUG_DIRECT == 0
+
+#define print_ram_emerg(STR)   print_emerg  (STR)
+#define print_ram_alert(STR)   print_alert  (STR)
+#define print_ram_crit(STR)    print_crit   (STR)
+#define print_ram_err(STR)     print_err    (STR)
+#define print_ram_warning(STR) print_warning(STR)
+#define print_ram_notice(STR)  print_notice (STR)
+#define print_ram_info(STR)    print_info   (STR)
+#define print_ram_debug(STR)   print_debug  (STR)
+#define print_ram_spew(STR)    print_spew   (STR)
+
+#define print_ram_emerg_char(CH)   print_emerg  (CH)
+#define print_ram_alert_char(CH)   print_alert  (CH)
+#define print_ram_crit_char(CH)    print_crit   (CH)
+#define print_ram_err_char(CH)     print_err    (CH)
+#define print_ram_warning_char(CH) print_warning(CH)
+#define print_ram_notice_char(CH)  print_notice (CH)
+#define print_ram_info_char(CH)    print_info   (CH)
+#define print_ram_debug_char(CH)   print_debug  (CH)
+#define print_ram_spew_char(CH)    print_spew   (CH)
+
+#define print_ram_emerg_hex8(HEX)   print_emerg  (HEX)
+#define print_ram_alert_hex8(HEX)   print_alert  (HEX)
+#define print_ram_crit_hex8(HEX)    print_crit   (HEX)
+#define print_ram_err_hex8(HEX)     print_err    (HEX)
+#define print_ram_warning_hex8(HEX) print_warning(HEX)
+#define print_ram_notice_hex8(HEX)  print_notice (HEX)
+#define print_ram_info_hex8(HEX)    print_info   (HEX)
+#define print_ram_debug_hex8(HEX)   print_debug  (HEX)
+#define print_ram_spew_hex8(HEX)    print_spew   (HEX)
+
+#define print_ram_emerg_hex16(HEX)   print_emerg  (HEX)
+#define print_ram_alert_hex16(HEX)   print_alert  (HEX)
+#define print_ram_crit_hex16(HEX)    print_crit   (HEX)
+#define print_ram_err_hex16(HEX)     print_err    (HEX)
+#define print_ram_warning_hex16(HEX) print_warning(HEX)
+#define print_ram_notice_hex16(HEX)  print_notice (HEX)
+#define print_ram_info_hex16(HEX)    print_info   (HEX)
+#define print_ram_debug_hex16(HEX)   print_debug  (HEX)
+#define print_ram_spew_hex16(HEX)    print_spew   (HEX)
+
+#define print_ram_emerg_hex32(HEX)   print_emerg  (HEX)
+#define print_ram_alert_hex32(HEX)   print_alert  (HEX)
+#define print_ram_crit_hex32(HEX)    print_crit   (HEX)
+#define print_ram_err_hex32(HEX)     print_err    (HEX)
+#define print_ram_warning_hex32(HEX) print_warning(HEX)
+#define print_ram_notice_hex32(HEX)  print_notice (HEX)
+#define print_ram_info_hex32(HEX)    print_info   (HEX)
+#define print_ram_debug_hex32(HEX)   print_debug  (HEX)
+#define print_ram_spew_hex32(HEX)    print_spew   (HEX)
+
+#endif
+
Index: src/arch/i386/lib/console.c
===================================================================
--- src/arch/i386/lib/console.c.orig
+++ src/arch/i386/lib/console.c
@@ -4,226 +4,33 @@
 static void __console_tx_byte(unsigned char byte)
 {
 	uart_tx_byte(byte);
+#if CONFIG_USBDEBUG_DIRECT
+	usbdebug_direct_tx_byte(byte);
+#endif
 }
-
-static void __console_tx_nibble(unsigned nibble)
+#if CONFIG_USBDEBUG_DIRECT
+static void __console_ram_tx_byte(unsigned char byte)
 {
-	unsigned char digit;
-	digit = nibble + '0';
-	if (digit > '9') {
-		digit += 39;
-	}
-	__console_tx_byte(digit);
+	uart_tx_byte(byte);
+	usbdebug_direct_ram_tx_byte(byte);
 }
+#endif
 
-static void __console_tx_char(int loglevel, unsigned char byte)
-{
-	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
-		uart_tx_byte(byte);
-	}
-}
+#include "console_print.c"
+#include "console_print_ram.c"
 
-static void __console_tx_hex8(int loglevel, unsigned char value)
-{
-	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
-		__console_tx_nibble((value >>  4U) & 0x0fU);
-		__console_tx_nibble(value & 0x0fU);
-	}
-}
+#else /* CONFIG_USE_PRINTK_IN_CAR == 1 */ 
 
-static void __console_tx_hex16(int loglevel, unsigned short value)
-{
-	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
-		__console_tx_nibble((value >> 12U) & 0x0fU);
-		__console_tx_nibble((value >>  8U) & 0x0fU);
-		__console_tx_nibble((value >>  4U) & 0x0fU);
-		__console_tx_nibble(value & 0x0fU);
-	}
-}
+#include "console_printk.c"
+#include "console_printk_ram.c"
 
-static void __console_tx_hex32(int loglevel, unsigned int value)
-{
-	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
-		__console_tx_nibble((value >> 28U) & 0x0fU);
-		__console_tx_nibble((value >> 24U) & 0x0fU);
-		__console_tx_nibble((value >> 20U) & 0x0fU);
-		__console_tx_nibble((value >> 16U) & 0x0fU);
-		__console_tx_nibble((value >> 12U) & 0x0fU);
-		__console_tx_nibble((value >>  8U) & 0x0fU);
-		__console_tx_nibble((value >>  4U) & 0x0fU);
-		__console_tx_nibble(value & 0x0fU);
-	}
-}
+// do_printk
+#include "../../../console/vtxprintf.c"
+#include "printk_init.c"
 
-static void __console_tx_string(int loglevel, const char *str)
-{
-	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
-		unsigned char ch;
-		while((ch = *str++) != '\0') {
-			__console_tx_byte(ch);
-		}
-	}
-}
-
-#define NOINLINE __attribute__((noinline))
-static void print_emerg_char(unsigned char byte) { __console_tx_char(BIOS_EMERG, byte); }
-static void print_emerg_hex8(unsigned char value){ __console_tx_hex8(BIOS_EMERG, value); }
-static void print_emerg_hex16(unsigned short value){ __console_tx_hex16(BIOS_EMERG, value); }
-static void print_emerg_hex32(unsigned int value) { __console_tx_hex32(BIOS_EMERG, value); }
-static void print_emerg(const char *str) { __console_tx_string(BIOS_EMERG, str); }
-
-static void print_alert_char(unsigned char byte) { __console_tx_char(BIOS_ALERT, byte); }
-static void print_alert_hex8(unsigned char value) { __console_tx_hex8(BIOS_ALERT, value); }
-static void print_alert_hex16(unsigned short value){ __console_tx_hex16(BIOS_ALERT, value); }
-static void print_alert_hex32(unsigned int value) { __console_tx_hex32(BIOS_ALERT, value); }
-static void print_alert(const char *str) { __console_tx_string(BIOS_ALERT, str); }
-
-static void print_crit_char(unsigned char byte) { __console_tx_char(BIOS_CRIT, byte); }
-static void print_crit_hex8(unsigned char value) { __console_tx_hex8(BIOS_CRIT, value); }
-static void print_crit_hex16(unsigned short value){ __console_tx_hex16(BIOS_CRIT, value); }
-static void print_crit_hex32(unsigned int value) { __console_tx_hex32(BIOS_CRIT, value); }
-static void print_crit(const char *str) { __console_tx_string(BIOS_CRIT, str); }
-
-static void print_err_char(unsigned char byte) { __console_tx_char(BIOS_ERR, byte); }
-static void print_err_hex8(unsigned char value) { __console_tx_hex8(BIOS_ERR, value); }
-static void print_err_hex16(unsigned short value){ __console_tx_hex16(BIOS_ERR, value); }
-static void print_err_hex32(unsigned int value) { __console_tx_hex32(BIOS_ERR, value); }
-static void print_err(const char *str) { __console_tx_string(BIOS_ERR, str); }
-
-static void print_warning_char(unsigned char byte) { __console_tx_char(BIOS_WARNING, byte); }
-static void print_warning_hex8(unsigned char value) { __console_tx_hex8(BIOS_WARNING, value); }
-static void print_warning_hex16(unsigned short value){ __console_tx_hex16(BIOS_WARNING, value); }
-static void print_warning_hex32(unsigned int value) { __console_tx_hex32(BIOS_WARNING, value); }
-static void print_warning(const char *str) { __console_tx_string(BIOS_WARNING, str); }
-
-static void print_notice_char(unsigned char byte) { __console_tx_char(BIOS_NOTICE, byte); }
-static void print_notice_hex8(unsigned char value) { __console_tx_hex8(BIOS_NOTICE, value); }
-static void print_notice_hex16(unsigned short value){ __console_tx_hex16(BIOS_NOTICE, value); }
-static void print_notice_hex32(unsigned int value) { __console_tx_hex32(BIOS_NOTICE, value); }
-static void print_notice(const char *str) { __console_tx_string(BIOS_NOTICE, str); }
-
-static void print_info_char(unsigned char byte) { __console_tx_char(BIOS_INFO, byte); }
-static void print_info_hex8(unsigned char value) { __console_tx_hex8(BIOS_INFO, value); }
-static void print_info_hex16(unsigned short value){ __console_tx_hex16(BIOS_INFO, value); }
-static void print_info_hex32(unsigned int value) { __console_tx_hex32(BIOS_INFO, value); }
-static void print_info(const char *str) { __console_tx_string(BIOS_INFO, str); }
-
-static void print_debug_char(unsigned char byte) { __console_tx_char(BIOS_DEBUG, byte); }
-static void print_debug_hex8(unsigned char value) { __console_tx_hex8(BIOS_DEBUG, value); }
-static void print_debug_hex16(unsigned short value){ __console_tx_hex16(BIOS_DEBUG, value); }
-static void print_debug_hex32(unsigned int value) { __console_tx_hex32(BIOS_DEBUG, value); }
-static void print_debug(const char *str) { __console_tx_string(BIOS_DEBUG, str); }
-
-static void print_spew_char(unsigned char byte) { __console_tx_char(BIOS_SPEW, byte); }
-static void print_spew_hex8(unsigned char value) { __console_tx_hex8(BIOS_SPEW, value); }
-static void print_spew_hex16(unsigned short value){ __console_tx_hex16(BIOS_SPEW, value); }
-static void print_spew_hex32(unsigned int value) { __console_tx_hex32(BIOS_SPEW, value); }
-static void print_spew(const char *str) { __console_tx_string(BIOS_SPEW, str); }
-
-#else  
-/* CONFIG_USE_INIT == 1 */
-
-extern int do_printk(int msg_level, const char *fmt, ...);
-
-#define printk_emerg(fmt, arg...)   do_printk(BIOS_EMERG   ,fmt, ##arg)
-#define printk_alert(fmt, arg...)   do_printk(BIOS_ALERT   ,fmt, ##arg)
-#define printk_crit(fmt, arg...)    do_printk(BIOS_CRIT    ,fmt, ##arg)
-#define printk_err(fmt, arg...)     do_printk(BIOS_ERR     ,fmt, ##arg)
-#define printk_warning(fmt, arg...) do_printk(BIOS_WARNING ,fmt, ##arg)
-#define printk_notice(fmt, arg...)  do_printk(BIOS_NOTICE  ,fmt, ##arg)
-#define printk_info(fmt, arg...)    do_printk(BIOS_INFO    ,fmt, ##arg)
-#define printk_debug(fmt, arg...)   do_printk(BIOS_DEBUG   ,fmt, ##arg)
-#define printk_spew(fmt, arg...)    do_printk(BIOS_SPEW    ,fmt, ##arg)
-
-#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_EMERG
-#undef  printk_emerg
-#define printk_emerg(fmt, arg...)   do {} while(0)
-#endif
-#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_ALERT
-#undef  printk_alert
-#define printk_alert(fmt, arg...)   do {} while(0)
-#endif
-#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_CRIT
-#undef  printk_crit
-#define printk_crit(fmt, arg...)    do {} while(0)
-#endif
-#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_ERR
-#undef  printk_err
-#define printk_err(fmt, arg...)     do {} while(0)
-#endif
-#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_WARNING
-#undef  printk_warning
-#define printk_warning(fmt, arg...) do {} while(0)
 #endif
-#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_NOTICE
-#undef  printk_notice
-#define printk_notice(fmt, arg...)  do {} while(0)
-#endif
-#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_INFO
-#undef  printk_info
-#define printk_info(fmt, arg...)    do {} while(0)
-#endif
-#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_DEBUG
-#undef  printk_debug
-#define printk_debug(fmt, arg...)   do {} while(0)
-#endif
-#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_SPEW
-#undef  printk_spew
-#define printk_spew(fmt, arg...)    do {} while(0)
-#endif
-
-#define print_emerg(STR)   printk_emerg  ("%s", (STR))
-#define print_alert(STR)   printk_alert  ("%s", (STR))
-#define print_crit(STR)    printk_crit   ("%s", (STR))
-#define print_err(STR)     printk_err    ("%s", (STR))
-#define print_warning(STR) printk_warning("%s", (STR))
-#define print_notice(STR)  printk_notice ("%s", (STR))
-#define print_info(STR)    printk_info   ("%s", (STR))
-#define print_debug(STR)   printk_debug  ("%s", (STR))
-#define print_spew(STR)    printk_spew   ("%s", (STR))
-
-#define print_emerg_char(CH)   printk_emerg  ("%c", (CH))
-#define print_alert_char(CH)   printk_alert  ("%c", (CH))
-#define print_crit_char(CH)    printk_crit   ("%c", (CH))
-#define print_err_char(CH)     printk_err    ("%c", (CH))
-#define print_warning_char(CH) printk_warning("%c", (CH))
-#define print_notice_char(CH)  printk_notice ("%c", (CH))
-#define print_info_char(CH)    printk_info   ("%c", (CH))
-#define print_debug_char(CH)   printk_debug  ("%c", (CH))
-#define print_spew_char(CH)    printk_spew   ("%c", (CH))
-
-#define print_emerg_hex8(HEX)   printk_emerg  ("%02x",  (HEX))
-#define print_alert_hex8(HEX)   printk_alert  ("%02x",  (HEX))
-#define print_crit_hex8(HEX)    printk_crit   ("%02x",  (HEX))
-#define print_err_hex8(HEX)     printk_err    ("%02x",  (HEX))
-#define print_warning_hex8(HEX) printk_warning("%02x",  (HEX))
-#define print_notice_hex8(HEX)  printk_notice ("%02x",  (HEX))
-#define print_info_hex8(HEX)    printk_info   ("%02x",  (HEX))
-#define print_debug_hex8(HEX)   printk_debug  ("%02x",  (HEX))
-#define print_spew_hex8(HEX)    printk_spew   ("%02x",  (HEX))
-
-#define print_emerg_hex16(HEX)   printk_emerg  ("%04x", (HEX))
-#define print_alert_hex16(HEX)   printk_alert  ("%04x", (HEX))
-#define print_crit_hex16(HEX)    printk_crit   ("%04x", (HEX))
-#define print_err_hex16(HEX)     printk_err    ("%04x", (HEX))
-#define print_warning_hex16(HEX) printk_warning("%04x", (HEX))
-#define print_notice_hex16(HEX)  printk_notice ("%04x", (HEX))
-#define print_info_hex16(HEX)    printk_info   ("%04x", (HEX))
-#define print_debug_hex16(HEX)   printk_debug  ("%04x", (HEX))
-#define print_spew_hex16(HEX)    printk_spew   ("%04x", (HEX))
-
-#define print_emerg_hex32(HEX)   printk_emerg  ("%08x", (HEX))
-#define print_alert_hex32(HEX)   printk_alert  ("%08x", (HEX))
-#define print_crit_hex32(HEX)    printk_crit   ("%08x", (HEX))
-#define print_err_hex32(HEX)     printk_err    ("%08x", (HEX))
-#define print_warning_hex32(HEX) printk_warning("%08x", (HEX))
-#define print_notice_hex32(HEX)  printk_notice ("%08x", (HEX))
-#define print_info_hex32(HEX)    printk_info   ("%08x", (HEX))
-#define print_debug_hex32(HEX)   printk_debug  ("%08x", (HEX))
-#define print_spew_hex32(HEX)    printk_spew   ("%08x", (HEX))
-
 
-#endif /* CONFIG_USE_INIT */
+#include "console_ram.c" 
 
 #ifndef LINUXBIOS_EXTRA_VERSION
 #define LINUXBIOS_EXTRA_VERSION ""
Index: src/arch/i386/lib/console_print_ram.c
===================================================================
--- /dev/null
+++ src/arch/i386/lib/console_print_ram.c
@@ -0,0 +1,118 @@
+#if CONFIG_USBDEBUG_DIRECT
+
+static void __console_ram_tx_nibble(unsigned nibble)
+{
+	unsigned char digit;
+	digit = nibble + '0';
+	if (digit > '9') {
+		digit += 39;
+	}
+	__console_ram_tx_byte(digit);
+}
+
+static void __console_ram_tx_char(int loglevel, unsigned char byte)
+{
+	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
+		__console_ram_tx_byte(byte);
+	}
+}
+
+static void __console_ram_tx_hex8(int loglevel, unsigned char value)
+{
+	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
+		__console_ram_tx_nibble((value >>  4U) & 0x0fU);
+		__console_ram_tx_nibble(value & 0x0fU);
+	}
+}
+
+static void __console_ram_tx_hex16(int loglevel, unsigned short value)
+{
+	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
+		__console_ram_tx_nibble((value >> 12U) & 0x0fU);
+		__console_ram_tx_nibble((value >>  8U) & 0x0fU);
+		__console_ram_tx_nibble((value >>  4U) & 0x0fU);
+		__console_ram_tx_nibble(value & 0x0fU);
+	}
+}
+
+static void __console_ram_tx_hex32(int loglevel, unsigned int value)
+{
+	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
+		__console_ram_tx_nibble((value >> 28U) & 0x0fU);
+		__console_ram_tx_nibble((value >> 24U) & 0x0fU);
+		__console_ram_tx_nibble((value >> 20U) & 0x0fU);
+		__console_ram_tx_nibble((value >> 16U) & 0x0fU);
+		__console_ram_tx_nibble((value >> 12U) & 0x0fU);
+		__console_ram_tx_nibble((value >>  8U) & 0x0fU);
+		__console_ram_tx_nibble((value >>  4U) & 0x0fU);
+		__console_ram_tx_nibble(value & 0x0fU);
+	}
+}
+
+static void __console_ram_tx_string(int loglevel, const char *str)
+{
+	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
+		unsigned char ch;
+		while((ch = *str++) != '\0') {
+			__console_ram_tx_byte(ch);
+		}
+	}
+}
+
+#define NOINLINE __attribute__((noinline))
+static void print_ram_emerg_char(unsigned char byte) { __console_ram_tx_char(BIOS_EMERG, byte); }
+static void print_ram_emerg_hex8(unsigned char value){ __console_ram_tx_hex8(BIOS_EMERG, value); }
+static void print_ram_emerg_hex16(unsigned short value){ __console_ram_tx_hex16(BIOS_EMERG, value); }
+static void print_ram_emerg_hex32(unsigned int value) { __console_ram_tx_hex32(BIOS_EMERG, value); }
+static void print_ram_emerg(const char *str) { __console_ram_tx_string(BIOS_EMERG, str); }
+
+static void print_ram_alert_char(unsigned char byte) { __console_ram_tx_char(BIOS_ALERT, byte); }
+static void print_ram_alert_hex8(unsigned char value) { __console_ram_tx_hex8(BIOS_ALERT, value); }
+static void print_ram_alert_hex16(unsigned short value){ __console_ram_tx_hex16(BIOS_ALERT, value); }
+static void print_ram_alert_hex32(unsigned int value) { __console_ram_tx_hex32(BIOS_ALERT, value); }
+static void print_ram_alert(const char *str) { __console_ram_tx_string(BIOS_ALERT, str); }
+
+static void print_ram_crit_char(unsigned char byte) { __console_ram_tx_char(BIOS_CRIT, byte); }
+static void print_ram_crit_hex8(unsigned char value) { __console_ram_tx_hex8(BIOS_CRIT, value); }
+static void print_ram_crit_hex16(unsigned short value){ __console_ram_tx_hex16(BIOS_CRIT, value); }
+static void print_ram_crit_hex32(unsigned int value) { __console_ram_tx_hex32(BIOS_CRIT, value); }
+static void print_ram_crit(const char *str) { __console_ram_tx_string(BIOS_CRIT, str); }
+
+static void print_ram_err_char(unsigned char byte) { __console_ram_tx_char(BIOS_ERR, byte); }
+static void print_ram_err_hex8(unsigned char value) { __console_ram_tx_hex8(BIOS_ERR, value); }
+static void print_ram_err_hex16(unsigned short value){ __console_ram_tx_hex16(BIOS_ERR, value); }
+static void print_ram_err_hex32(unsigned int value) { __console_ram_tx_hex32(BIOS_ERR, value); }
+static void print_ram_err(const char *str) { __console_ram_tx_string(BIOS_ERR, str); }
+
+static void print_ram_warning_char(unsigned char byte) { __console_ram_tx_char(BIOS_WARNING, byte); }
+static void print_ram_warning_hex8(unsigned char value) { __console_ram_tx_hex8(BIOS_WARNING, value); }
+static void print_ram_warning_hex16(unsigned short value){ __console_ram_tx_hex16(BIOS_WARNING, value); }
+static void print_ram_warning_hex32(unsigned int value) { __console_ram_tx_hex32(BIOS_WARNING, value); }
+static void print_ram_warning(const char *str) { __console_ram_tx_string(BIOS_WARNING, str); }
+
+static void print_ram_notice_char(unsigned char byte) { __console_ram_tx_char(BIOS_NOTICE, byte); }
+static void print_ram_notice_hex8(unsigned char value) { __console_ram_tx_hex8(BIOS_NOTICE, value); }
+static void print_ram_notice_hex16(unsigned short value){ __console_ram_tx_hex16(BIOS_NOTICE, value); }
+static void print_ram_notice_hex32(unsigned int value) { __console_ram_tx_hex32(BIOS_NOTICE, value); }
+static void print_ram_notice(const char *str) { __console_ram_tx_string(BIOS_NOTICE, str); }
+
+static void print_ram_info_char(unsigned char byte) { __console_ram_tx_char(BIOS_INFO, byte); }
+static void print_ram_info_hex8(unsigned char value) { __console_ram_tx_hex8(BIOS_INFO, value); }
+static void print_ram_info_hex16(unsigned short value){ __console_ram_tx_hex16(BIOS_INFO, value); }
+static void print_ram_info_hex32(unsigned int value) { __console_ram_tx_hex32(BIOS_INFO, value); }
+static void print_ram_info(const char *str) { __console_ram_tx_string(BIOS_INFO, str); }
+
+static void print_ram_debug_char(unsigned char byte) { __console_ram_tx_char(BIOS_DEBUG, byte); }
+static void print_ram_debug_hex8(unsigned char value) { __console_ram_tx_hex8(BIOS_DEBUG, value); }
+static void print_ram_debug_hex16(unsigned short value){ __console_ram_tx_hex16(BIOS_DEBUG, value); }
+static void print_ram_debug_hex32(unsigned int value) { __console_ram_tx_hex32(BIOS_DEBUG, value); }
+static void print_ram_debug(const char *str) { __console_ram_tx_string(BIOS_DEBUG, str); }
+
+static void print_ram_spew_char(unsigned char byte) { __console_ram_tx_char(BIOS_SPEW, byte); }
+static void print_ram_spew_hex8(unsigned char value) { __console_ram_tx_hex8(BIOS_SPEW, value); }
+static void print_ram_spew_hex16(unsigned short value){ __console_ram_tx_hex16(BIOS_SPEW, value); }
+static void print_ram_spew_hex32(unsigned int value) { __console_ram_tx_hex32(BIOS_SPEW, value); }
+static void print_ram_spew(const char *str) { __console_ram_tx_string(BIOS_SPEW, str); }
+
+#endif
+
